/**
 * Add all event listeners when the window is loaded.
 */
$(window).load(function() {	
	timer = new Timer();
	front = new Front();
	updater = new Updater();
	
	if (window.widget) {
		widget.onremove = remove;
		widget.onhide = hide;
		widget.onshow = show;
	}
});

/**
 * Called when the widget has been removed from the Dashboard.
 */
function remove() {
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
}

/**
 * Called when the widget has been hidden.
 */
function hide() {
	// Don't stop the timer or you'll forget your tea!
}

/**
 * Called when the widget has been shown.
 */
function show() {
	updater.check();
}

/**
 * Called when the info button is clicked to show the back of the widget.
 *
 * @param event: onClick event from the info button
 */
function showBack(event) {
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

/**
 * Called when the done button is clicked from the back of the widget.
 *
 * @param event: onClick event from the done button
 */
function showFront(event) {
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}
